package in.slanglabs.assistants.retail.appStateAdapter;

import in.slanglabs.assistants.retail.appstates.NavigationAppState;
import in.slanglabs.assistants.retail.appstates.NavigationCompleteAppState;
import in.slanglabs.assistants.retail.appstates.UnsupportedAppState;
import in.slanglabs.assistants.retail.appstates.WaitingAppState;

public class NavigationAppStateAdapter {

    public static NavigationAppState getNavigationAppState(String appState, String condition) {
        if (appState == null) {
            return new UnsupportedAppState();
        }

        switch (appState) {
            case "unsupported":
                return new UnsupportedAppState();
            case "waiting":
                return new WaitingAppState();
            default:
                NavigationCompleteAppState.Condition navigationAppStateCondition = findNavigationAppStateCondition(condition);
                return new NavigationCompleteAppState(navigationAppStateCondition);
        }
    }
    private static NavigationCompleteAppState.Condition findNavigationAppStateCondition(String appStateConditionString) {
        if (appStateConditionString == null) {
            return NavigationCompleteAppState.FAILURE;
        }

        switch (appStateConditionString) {
            case "success":
                return NavigationCompleteAppState.SUCCESS;
            case "failure_generic":
                return NavigationCompleteAppState.FAILURE;
            default:
                return NavigationCompleteAppState.NAVIGATION_TARGET_NOT_SPECIFIED;
        }
    }
}
