package in.slanglabs.assistants.retail.appStateAdapter;

import in.slanglabs.assistants.retail.appstates.OrderCancelAppState;
import in.slanglabs.assistants.retail.appstates.OrderManagementAppState;
import in.slanglabs.assistants.retail.appstates.OrderViewAppState;
import in.slanglabs.assistants.retail.appstates.UnsupportedAppState;
import in.slanglabs.assistants.retail.appstates.WaitingAppState;

public class OrderManagementAppStateAdapter {

    public static OrderManagementAppState getOrderManagementAppState(String appState, String condition) {
        if (appState == null) {
            return new UnsupportedAppState();
        }

        switch (appState) {
            case "unsupported":
                return new UnsupportedAppState();
            case "waiting":
                return new WaitingAppState();
            case "view_order":
                OrderViewAppState.Condition orderViewAppStateCondition = findOrderViewAppStateCondition(condition);
                return new OrderViewAppState(orderViewAppStateCondition);
            default:
                OrderCancelAppState.Condition orderCancelAppStateCondition = findOrderCancelAppStateCondition(condition);
                return new OrderCancelAppState(orderCancelAppStateCondition);
        }
    }

    private static OrderViewAppState.Condition findOrderViewAppStateCondition(String appStateConditionString) {
        if (appStateConditionString == null) {
            return OrderViewAppState.FAILURE;
        }

        switch (appStateConditionString) {
            case "success":
                return OrderViewAppState.SUCCESS;
            case "failure_generic":
                return OrderViewAppState.FAILURE;
            case "no_orders":
                return OrderViewAppState.ORDER_HISTORY_EMPTY;
            case "order_does_not_exist":
                return OrderViewAppState.ORDER_NOT_FOUND;
            default:
                return OrderViewAppState.ORDER_INDEX_REQUIRED;
        }
    }

    private static OrderCancelAppState.Condition findOrderCancelAppStateCondition(String appStateConditionString) {
        if (appStateConditionString == null) {
            return OrderCancelAppState.FAILURE;
        }

        switch (appStateConditionString) {
            case "success":
                return OrderCancelAppState.SUCCESS;
            case "failure_generic":
                return OrderCancelAppState.FAILURE;
            case "confirmation_required":
                return OrderCancelAppState.ORDER_CANCEL_CONFIRMATION_REQUIRED;
            case "user_confirmed":
                return OrderCancelAppState.ORDER_CANCEL_USER_CONFIRMED;
            case "user_denied":
                return OrderCancelAppState.ORDER_CANCEL_USER_DENIED;
            case "select_order":
                return OrderCancelAppState.ORDER_CANCEL_SELECT;
            case "order_does_not_exist":
                return OrderCancelAppState.ORDER_NOT_FOUND;
            case "no_orders":
                return OrderCancelAppState.ORDER_HISTORY_EMPTY;
            default:
                return OrderCancelAppState.ORDER_INDEX_REQUIRED;
        }
    }
}
