package in.slanglabs.assistants.retail.appStateAdapter;

import in.slanglabs.assistants.retail.appstates.AddToCartAppState;
import in.slanglabs.assistants.retail.appstates.SearchAppState;
import in.slanglabs.assistants.retail.appstates.SearchResultsAppState;
import in.slanglabs.assistants.retail.appstates.UnsupportedAppState;
import in.slanglabs.assistants.retail.appstates.WaitingAppState;

public class SearchAppStateAdapter {
    public static SearchAppState getSearchAppState(String appState, String condition) {
        if (appState == null) {
            return new UnsupportedAppState();
        }

        switch (appState) {
            case "unsupported":
                return new UnsupportedAppState();
            case "waiting":
                return new WaitingAppState();
            case "search_results":
                SearchResultsAppState.Condition searchAppStateCondition = findSearchResultAppStateCondition(condition);
                return new SearchResultsAppState(searchAppStateCondition);
            default:
                AddToCartAppState.Condition addToCartAppStateCondition = findAddToCartAppStateCondition(condition);
                return new AddToCartAppState(addToCartAppStateCondition);
        }

    }

    private static SearchResultsAppState.Condition findSearchResultAppStateCondition(String appStateConditionString) {
        if (appStateConditionString == null) {
            return SearchResultsAppState.FAILURE;
        }

        switch (appStateConditionString) {
            case "success":
                return SearchResultsAppState.SUCCESS;
            case "failure_generic":
                return SearchResultsAppState.FAILURE;
            case "failure_item_not_found":
                return SearchResultsAppState.ITEM_NOT_FOUND;
            case "failure_out_of_stock":
                return SearchResultsAppState.ITEM_OUT_OF_STOCK;
            default:
                return SearchResultsAppState.ITEM_NOT_SPECIFIED;
        }
    }

    private static AddToCartAppState.Condition findAddToCartAppStateCondition(String appStateConditionString) {
        if (appStateConditionString == null) {
            return AddToCartAppState.FAILURE;
        }

        switch (appStateConditionString) {
            case "success":
                return AddToCartAppState.SUCCESS;
            case "failure_generic":
                return AddToCartAppState.FAILURE;
            case "failure_item_not_found":
                return AddToCartAppState.ITEM_NOT_FOUND;
            case "failure_out_of_stock":
                return AddToCartAppState.ITEM_OUT_OF_STOCK;
            case "item_not_specified":
                return AddToCartAppState.ITEM_NOT_SPECIFIED;
            case "size_required":
                return AddToCartAppState.ITEM_SIZE_REQUIRED;
            case "quantity_required":
                return AddToCartAppState.ITEM_QUANTITY_REQUIRED;
            case "ambiguous":
                return AddToCartAppState.ITEM_AMBIGUOUS;
            case "ambiguous_bailout":
                return AddToCartAppState.ITEM_AMBIGUOUS_FORCE_UI;
            case "push_promotion_percentage":
                return AddToCartAppState.PUSH_PROMOTION_PERCENTAGE;
            case "push_promotion_price":
                return AddToCartAppState.PUSH_PROMOTION_PRICE;
            case "push_promotion_quantity":
                return AddToCartAppState.PUSH_PROMOTION_QUANTITY;
            case "push_promotion_free_item":
                return AddToCartAppState.PUSH_PROMOTION_FREE_ITEM;
            default:
                return AddToCartAppState.PUSH_PROMOTION_APP_TEXT;
        }

    }

}
