//
//  Copyright (c) 2017-2021 Slang Labs Private Limited. All rights reserved.
//  

import Foundation
import Slang

class SlangRetailAssistantLocaleMap {
    
    private static let localeMap = [
        "en-IN":SlangLocale.localeEnglishIN,
        "hi-IN":SlangLocale.localeHindiIN,
        "kn-IN":SlangLocale.localeKannadaIN,
        "ta-IN":SlangLocale.localeTamilIN,
        "ml-IN":SlangLocale.localeMalayalamIN
    ]
    
    static func getRequestedLocales(_ locales:[String]) -> Set<Locale> {
        var requestesLocales = Set<Locale>()
        if !locales.isEmpty {
            for locale in locales {
                if let mappedLocale = localeMap[locale] {
                    requestesLocales.insert(mappedLocale)
                }
            }
        }
        
        if requestesLocales.isEmpty {
            requestesLocales.insert(SlangLocale.localeEnglishIN)
            requestesLocales.insert(SlangLocale.localeHindiIN)
        }
        
        return requestesLocales
    }
    
    static func getDefaultLocale(_ locale:String) -> Locale {
        if let mappedLocale = localeMap[locale] {
            return mappedLocale
        }
        return SlangLocale.localeEnglishIN
    }
    
}
