part of slang_retail_assistant;

abstract class RetailCondition implements BaseCondition {
  static final String nameSuccess = "success";
  static final String nameFailure = "failure_generic";

  // Search
  static final String nameItemNotFound = "failure_item_not_found";
  static final String nameItemOutOfStock = "failure_out_of_stock";
  static final String nameItemNotSpecified = "item_not_specified";
  static final String nameItemSizeRequired = "size_required";
  static final String nameItemQuantityRequired = "quantity_required";
  static final String nameItemAmbiguous = "ambiguous";
  static final String nameItemAmbiguousForceUI = "ambiguous_bailout";
  static final String nameItemPushPromotionPercentage =
      "push_promotion_percentage";
  static final String nameItemPushPromotionPrice = "push_promotion_price";
  static final String nameItemPushPromotionQuantity = "push_promotion_quantity";
  static final String nameItemPushPromotionFreeItem =
      "push_promotion_free_item";
  static final String nameItemPushPromotionAppText = "push_promotion_app_text";

  // Order management
  static final String nameOrderNotFound = "order_does_not_exist";
  static final String nameOrderHistoryEmpty = "no_orders";
  static final String nameOrderIndexRequired = "index_required";
  static final String nameOrderCancelConfirmationRequired =
      "confirmation_required";
  static final String nameOrderCancelUserConfirmed = "user_confirmed";
  static final String nameOrderCancelUserDenied = "user_denied";
  static final String nameOrderCancelSelect = "select_order";

  // Navigation
  static final String nameNavigationTargetNotSpecified = "target_not_specified";

  late final String mName;
  RetailCondition(String name) {
    mName = name;
  }
  String getName() {
    return mName;
  }
}
