part of slang_retail_assistant;

class AssistantConfiguration {
  late String assistantId;
  late String apiKey;
  String? defaultLocale;
  List<String>? requestedLocales;
  bool? enableCustomTrigger,
      coachmarkVisibility,
      disableOnboardingLocaleSelection,
      disableOnboardingIntro,
      disableSurfaceLocaleSelection,
      disableHelpWindow,
      disableMuteButton,
      disableItalicStyle,
      disableCoachmark,
      enableSearchListFeedback,
      enableNonVoiceCompletionStatements,
      disableASRPermissionTalkback;
  AssistantUIPosition? uiPosition;
  AssistantUserJourney? userJourney;
  AssistantSubDomain? defaultSubDomain;
  AssistantEnvironment? environment;
  AssistantTriggerStyle? triggerStyle;
  AssistantSurfaceStyle? surfaceStyle;
  String? brandColor, infoTextColor, infoAccentColor;
  Map<String, String>? onboardingIdentifer,
      onboardingInfoTitle,
      onboardingInfoDescription,
      onboardingPrimaryTitle,
      onboardingPrimaryDescription,
      microphonePermissionText;
  double? onboardingInfoTitleSize, onboardingInfoDescriptionSize;
  int? automaticAppearanceLimit, startSpeechTimeoutMillis;

  HashMap<String, Object?> _covertToHashmap() {
    var configMap = HashMap<String, Object?>();
    configMap["assistantId"] = assistantId;
    configMap["apiKey"] = apiKey;
    configMap["defaultLocale"] = defaultLocale;
    configMap["requestedLocales"] = requestedLocales;
    configMap["enableCustomTrigger"] = enableCustomTrigger ?? false;
    configMap["coachmarkVisibility"] = coachmarkVisibility ?? null;
    configMap["disableOnboardingLocaleSelection"] =
        disableOnboardingLocaleSelection ?? null;
    configMap["disableOnboardingIntro"] = disableOnboardingIntro ?? null;
    configMap["disableSurfaceLocaleSelection"] =
        disableSurfaceLocaleSelection ?? null;
    configMap["disableHelpWindow"] = disableHelpWindow ?? null;
    configMap["disableMuteButton"] = disableMuteButton ?? null;
    configMap["disableItalicStyle"] = disableItalicStyle ?? null;
    configMap["disableCoachmark"] = disableCoachmark ?? null;
    configMap["enableSearchListFeedback"] = enableSearchListFeedback ?? null;
    configMap["enableNonVoiceCompletionStatements"] =
        enableNonVoiceCompletionStatements ?? null;
    configMap["triggerPosition"] = uiPosition?._covertToHashmap();
    configMap["defaultSubDomain"] = defaultSubDomain?.stringValue;
    configMap["defaultUserJourney"] = userJourney?.stringValue;
    configMap["environment"] = environment?.stringValue;
    configMap["triggerStyle"] = triggerStyle?.stringValue;
    configMap["surfaceStyle"] = surfaceStyle?.stringValue;
    configMap["brandColor"] = brandColor;
    configMap["onboardingIdentifer"] = onboardingIdentifer;
    configMap["onboardingInfoTitle"] = onboardingInfoTitle;
    configMap["onboardingInfoDescription"] = onboardingInfoDescription;
    configMap["onboardingInfoTitleSize"] = onboardingInfoTitleSize;
    configMap["onboardingInfoDescriptionSize"] = onboardingInfoDescriptionSize;
    configMap["onboardingPrimaryTitle"] = onboardingPrimaryTitle;
    configMap["onboardingPrimaryDescription"] = onboardingPrimaryDescription;
    configMap["infoTextColor"] = infoTextColor;
    configMap["infoAccentColor"] = infoAccentColor;
    configMap["automaticAppearanceLimit"] = automaticAppearanceLimit;
    configMap["startSpeechTimeoutMillis"] = startSpeechTimeoutMillis;
    configMap["disableASRPermissionTalkback"] = disableASRPermissionTalkback;
    configMap["microphonePermissionText"] = microphonePermissionText;
    return configMap;
  }
}
