part of slang_retail_assistant;

class NavigationUserJourney {
  NavigationUserJourney._() {
    print('NavigationUserJourney constructor');
  }

  static const MethodChannel _channel =
      const MethodChannel('plugins.flutter.io/slang_retail_assistant');

  static NavigationContext getContext() {
    NavigationContext._channel = _channel;
    return const NavigationContext();
  }

  static void disablePreserveContext() {
    _channel.invokeMethod("disableNavigationUserJourneyContext");
  }

  static void clearPreserveContext() {
    _channel.invokeMethod("clearNavigationUserJourneyContext");
  }

  void setUserJourneyToContinue(
      AssistantUserJourney assistantUserJourney, bool isSpoken) {
    _channel.invokeMapMethod("setUserJourneyToContinue", {
      "currentUserJourney": AssistantUserJourney.NAVIGATION.stringValue,
      "userJourneyToContinue": assistantUserJourney.stringValue,
      "isSpoken": isSpoken
    });
  }

  void clearUserJourneyToContinue() {
    _channel.invokeMapMethod("clearUserJourneyToContinue",
        {"currentUserJourney": AssistantUserJourney.NAVIGATION.stringValue});
  }

  void notifyAppState(NavigationAppState appState) {
    if (!SlangRetailAssistant._validateEnvironment()) {
      return;
    }
    String stringAppState = '';
    String? stringAppStateCondition = '';
    stringAppState = appState.getName();
    stringAppStateCondition = appState.getCondition()?.getName();
    _channel.invokeMapMethod("notifyNavigationActionCompleted", {
      "appState": stringAppState,
      "appStateCondition": stringAppStateCondition
    });
  }
}

class NavigationContext {
  const NavigationContext();

  static late MethodChannel _channel;

  void clear() {
    _channel.invokeMethod("clearNavigationUserJourneyContext");
  }
}
