part of slang_retail_assistant;

class OrderManagementUserJourney {
  OrderManagementUserJourney._();

  static const MethodChannel _channel =
      const MethodChannel('plugins.flutter.io/slang_retail_assistant');

  static OrderManagementContext getContext() {
    OrderManagementContext._channel = _channel;
    return const OrderManagementContext();
  }

  static void disablePreserveContext() {
    _channel.invokeMethod("disableOrderManagementUserJourneyContext");
  }

  void setUserJourneyToContinue(
      AssistantUserJourney assistantUserJourney, bool isSpoken) {
    _channel.invokeMapMethod("setUserJourneyToContinue", {
      "currentUserJourney": AssistantUserJourney.ORDER_MANAGEMENT.stringValue,
      "userJourneyToContinue": assistantUserJourney.stringValue,
      "isSpoken": isSpoken
    });
  }

  void clearUserJourneyToContinue() {
    _channel.invokeMapMethod("clearUserJourneyToContinue", {
      "currentUserJourney": AssistantUserJourney.ORDER_MANAGEMENT.stringValue
    });
  }

  void notifyAppState(OrderManagementAppState appState) {
    if (!SlangRetailAssistant._validateEnvironment()) {
      return;
    }
    String stringAppState = '';
    String? stringAppStateCondition = '';
    stringAppState = appState.getName();
    stringAppStateCondition = appState.getCondition()?.getName();
    _channel.invokeMapMethod("notifyOrderManagementActionCompleted", {
      "appState": stringAppState,
      "appStateCondition": stringAppStateCondition
    });
  }
}

class OrderManagementContext {
  const OrderManagementContext();

  static late MethodChannel _channel;

  void clear() {
    _channel.invokeMethod("clearOrderManagementUserJourneyContext");
  }
}
