part of slang_retail_assistant;

class SearchUserJourney {
  SearchUserJourney._();

  static const MethodChannel _channel =
      const MethodChannel('plugins.flutter.io/slang_retail_assistant');

  static SearchContext getContext() {
    SearchContext._channel = _channel;
    return const SearchContext();
  }

  static void disablePreserveContext() {
    _channel.invokeMethod("disableSearchUserJourneyContext");
  }

  void setUserJourneyToContinue(
      AssistantUserJourney assistantUserJourney, bool isSpoken) {
    _channel.invokeMapMethod("setUserJourneyToContinue", {
      "currentUserJourney": AssistantUserJourney.SEARCH.stringValue,
      "userJourneyToContinue": assistantUserJourney.stringValue,
      "isSpoken": isSpoken
    });
  }

  void clearUserJourneyToContinue() {
    _channel.invokeMapMethod("clearUserJourneyToContinue",
        {"currentUserJourney": AssistantUserJourney.SEARCH.stringValue});
  }

  void notifyAppState(SearchAppState appState) {
    if (!SlangRetailAssistant._validateEnvironment()) {
      return;
    }

    String stringAppState = '';
    String? stringAppStateCondition = '';
    stringAppState = appState.getName();
    stringAppStateCondition = appState.getCondition()?.getName();
    _channel.invokeMapMethod("notifySearchActionCompleted", {
      "appState": stringAppState,
      "appStateCondition": stringAppStateCondition
    });
  }
}

class SearchContext {
  const SearchContext();

  static late MethodChannel _channel;

  void clear() {
    _channel.invokeMethod("clearSearchUserJourneyContext");
  }

  void setItemBrand(brand) {
    _channel.invokeMethod("setItemBrand", {"brand": brand});
  }

  void setItemCategory(category) {
    _channel.invokeMethod("setItemCategory", {"category": category});
  }

  void setItemProductType(productType) {
    _channel.invokeMethod("setItemDescription", {"productType": productType});
  }

  void setItemDescription(description) {
    _channel.invokeMethod("setItemDescription", {"description": description});
  }

  void setItemPrice(Price price) {
    _channel.invokeMethod("setItemDescription", {"price": price.toJson()});
  }

  void setItemSize(Size size) {
    _channel.invokeMethod("setItemSize", {"size": size.toJson()});
  }

  void setItemVariants(List<String> variants) {
    _channel.invokeMethod("setItemVariants", {"variants": variants});
  }

  void setItemQuantity(Quantity quantity) {
    _channel.invokeMethod("setItemQuantity", {"quantity": quantity});
  }
}
